Bug 1805501 (CVE-2020-10693)

Summary: CVE-2020-10693 hibernate-validator: Improper input validation in the interpolation of constraint error messages
Product: [Other] Security Response Reporter: Pedro Sampaio <psampaio>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: medium Docs Contact:
Priority: medium    
Version: unspecifiedCC: aboyko, aileenc, akoufoud, alazarot, almorale, anstephe, asoldano, atangrin, avibelli, bbaranow, bbuckingham, bcourt, bgeorges, bkearney, bmaxwell, brian.stansberry, btotty, cdewolf, chazlett, cmoulliard, darran.lofthouse, dbecker, dkreling, dosoudil, drieden, etirelli, extras-orphan, ggaughan, gmalinko, gmorling, gsmet, gvarsami, hhudgeon, ibek, ikanello, iweiss, janstey, java-sig-commits, jawilson, jbalunas, jcoleman, jjoyce, jochrist, jolee, jpallich, jperkins, jschatte, jschluet, jstastny, jwon, kconner, krathod, kverlaen, kwills, ldimaggi, lef, lgao, lhh, loleary, lpeer, lthon, lzap, mburns, mkolesni, mmarcian, mmccune, mnovotny, msochure, msvehla, mszynkie, nmoumoul, nwallace, paradhya, pdrozd, pgallagh, pjindal, pmackay, psotirop, puntogil, rchan, rguimara, rjerrido, rrajasek, rruss, rstancel, rsvoboda, rsynek, rwagner, sanne, sclewis, scohen, sdaley, security-response-team, slinaber, smaestri, sokeeffe, spinder, sthorger, tbrisker, tcunning, theute, tkirby, tom.jenkinson, vhalbert
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: hibernate-validator 7.0.0.Alpha2, hibernate-validator 6.1.5.Final, hibernate-validator 6.0.20.Final Doc Type: If docs needed, set a value
Doc Text:
A flaw was found in Hibernate Validator version 6.1.2.Final. A bug in the message interpolation processor enables invalid EL expressions to be evaluated as if they were valid. This flaw allows attackers to bypass input sanitation (escaping, stripping) controls that developers may have put in place when handling user-controlled data in error messages.
Story Points: ---
Clone Of: Environment:
Last Closed: 2020-08-17 15:15:40 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Bug Depends On: 1817064, 1831527    
Bug Blocks: 1805503    

Description Pedro Sampaio 2020-02-20 21:54:48 UTC
A flaw was found in hibernate-validator 6.1.2.Final. A bug in the interpolation of constraint error messages code enables invalid EL expressions to be evaluated as if they were valid. This bug enables attackers to bypass input sanitation (escaping, stripping) controls that developers may have put in place when handling user-controlled data in error messages.

Comment 1 Pedro Sampaio 2020-02-20 22:00:11 UTC
Acknowledgments:

Name: Alvaro Muñoz (GitHub Security Labs)

Comment 5 Summer Long 2020-03-05 04:33:12 UTC
Statement:

hibernate-validator is packaged with Red Hat OpenStack Platform 13.0's OpenDaylight (ODL). However, because ODL is technical preview in this version and the flaw is moderate, Red Hat will not be releasing a fix for the OpenStack package at this time.

Comment 16 Ted (Jong Seok) Won 2020-05-05 07:13:12 UTC
Created hibernate-validator tracking bugs for this issue:

Affects: fedora-30 [bug 1831527]

Comment 21 Ted (Jong Seok) Won 2020-06-29 06:51:05 UTC
Mitigation:

You can pass user input as an expression variable by unwrapping the context to HibernateConstraintValidatorContext. Please refer to the https://in.relation.to/2020/05/07/hibernate-validator-615-6020-released/ and https://docs.jboss.org/hibernate/stable/validator/reference/en-US/html_single/#_the_code_constraintvalidatorcontext_code.

Comment 23 errata-xmlrpc 2020-08-17 13:25:55 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform

Via RHSA-2020:3464 https://access.redhat.com/errata/RHSA-2020:3464

Comment 24 errata-xmlrpc 2020-08-17 13:28:16 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.3 for RHEL 6

Via RHSA-2020:3461 https://access.redhat.com/errata/RHSA-2020:3461

Comment 25 errata-xmlrpc 2020-08-17 13:30:26 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.3 for RHEL 7

Via RHSA-2020:3462 https://access.redhat.com/errata/RHSA-2020:3462

Comment 26 errata-xmlrpc 2020-08-17 13:33:56 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.3 for RHEL 8

Via RHSA-2020:3463 https://access.redhat.com/errata/RHSA-2020:3463

Comment 27 Product Security DevOps Team 2020-08-17 15:15:40 UTC
This bug is now closed. Further updates for individual products will be reflected on the CVE page(s):

https://access.redhat.com/security/cve/cve-2020-10693

Comment 28 errata-xmlrpc 2020-08-18 16:35:05 UTC
This issue has been addressed in the following products:

  Red Hat Single Sign-On 7.4.2

Via RHSA-2020:3501 https://access.redhat.com/errata/RHSA-2020:3501

Comment 29 errata-xmlrpc 2020-09-02 09:47:29 UTC
This issue has been addressed in the following products:

  Red Hat Openshift Application Runtimes

Via RHSA-2020:3539 https://access.redhat.com/errata/RHSA-2020:3539

Comment 30 errata-xmlrpc 2020-09-07 12:56:08 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.2 for RHEL 6

Via RHSA-2020:3637 https://access.redhat.com/errata/RHSA-2020:3637

Comment 31 errata-xmlrpc 2020-09-07 12:59:09 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.2 for RHEL 8

Via RHSA-2020:3639 https://access.redhat.com/errata/RHSA-2020:3639

Comment 32 errata-xmlrpc 2020-09-07 13:02:14 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.2 for RHEL 7

Via RHSA-2020:3638 https://access.redhat.com/errata/RHSA-2020:3638

Comment 33 errata-xmlrpc 2020-09-07 13:06:33 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform

Via RHSA-2020:3642 https://access.redhat.com/errata/RHSA-2020:3642

Comment 34 errata-xmlrpc 2020-09-23 16:27:20 UTC
This issue has been addressed in the following products:

  Red Hat Runtimes Spring Boot 2.2.6

Via RHSA-2020:3806 https://access.redhat.com/errata/RHSA-2020:3806

Comment 36 errata-xmlrpc 2020-10-14 11:17:23 UTC
This issue has been addressed in the following products:

  Red Hat build of Quarkus 1.7.5

Via RHSA-2020:4252 https://access.redhat.com/errata/RHSA-2020:4252